/************************************************************************
 *
 *
 *
 ***********************************************************************/

// DFSTest.java
// Tests depth-first search.  Emulates Figure 22.4 on page 542 of
// Introduction to Algorithms, Second edition.

import com.mhhe.clrs2e.*;

public class DFSTest
{
    public static void main(String[] args)
    {
	Vertex u = new Vertex("u");
	Vertex v = new Vertex("v");
	Vertex w = new Vertex("w");
	Vertex x = new Vertex("x");
	Vertex y = new Vertex("y");
	Vertex z = new Vertex("z");

	AdjacencyListGraph g = new AdjacencyListGraph(6, true);
	g.addVertex(u);
	g.addVertex(v);
	g.addVertex(w);
	g.addVertex(x);
	g.addVertex(y);
	g.addVertex(z);

	g.addEdge(u,x);
	g.addEdge(u,v);
	g.addEdge(v,y);
	g.addEdge(w,z);
	g.addEdge(w,y);
	g.addEdge(x,v);
	g.addEdge(y,x);
	g.addEdge(z,z);

	System.out.println("Before DFS:");
	System.out.print(g);

	DFS dfs = new DFS();
	dfs.search(g);

	System.out.println("\n\nAfter DFS:");
	for (int i = 0; i < 6; i++) {
	    System.out.println(g.getVertex(i) + ": " + dfs.getDFSInfo(i));
	}
    }
}
